﻿Global ScriptJS.s = #Null$, Webcam.s = #Null$

Procedure CheckBoxHandler()
  If FindString(ScriptJS, "function saveBase64(blob){}")
    ScriptJS_Blob.s = #TAB$ + #TAB$ + "<script type='text/javascript'>" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "function saveBase64(blob){" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "var blobObject = new Blob([blob],{type:'image/jpeg'});" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + #TAB$ + "window.navigator.msSaveBlob(blobObject, 'snapshot_b64.dat');" + #LF$ +
                      #TAB$ + #TAB$ + #TAB$ + "}" + #LF$ +
                      #TAB$ + #TAB$ + "</script>" + #LF$
  Else
    ScriptJS_Blob = #TAB$ + #TAB$ + "<script type='text/javascript'>" + #LF$ +
                    #TAB$ + #TAB$ + #TAB$ + "function saveBase64(blob){}" + #LF$ +
                    #TAB$ + #TAB$ + "</script>" + #LF$
  EndIf
  Webcam = ReplaceString(Webcam, ScriptJS, ScriptJS_Blob)
  SetGadgetItemText(0, #PB_Web_HtmlCode, Webcam)
  ScriptJS = ScriptJS_Blob
EndProcedure

Procedure ButtonHandler()
  PageTitle.s = GetGadgetItemText(0, #PB_Web_PageTitle)

  If Len(PageTitle) > 100
    OutputSize = StringByteLength(PageTitle, #PB_Unicode) * 0.8
    *OutputBuffer = AllocateMemory(OutputSize)
    nLength = Base64Decoder(PageTitle, *OutputBuffer, OutputSize)
    Snapshot = CatchImage(#PB_Any, *OutputBuffer, nLength)
    FreeMemory(*OutputBuffer)

    If IsImage(Snapshot)
      ImageName.s = SaveFileRequester("Enter a file name", GetCurrentDirectory() + "TestFiles\", "JPEG Files (*.jpg)|*.jpg", 0)

      If ImageName
        If LCase(Right(ImageName, 4)) <> ".jpg" : ImageName + ".jpg" : EndIf

        SaveImage(Snapshot, ImageName, #PB_ImagePlugin_JPEG)
      EndIf
    EndIf
  Else
    MessageRequester("HTML5 AS3: Webcam", "Snapshot not available.", #MB_ICONEXCLAMATION)
  EndIf
EndProcedure

Procedure BuildCam(WebcamFolder.s, nWidth, nHeight)
  lpValueName.s = GetFilePart(ProgramFilename()) : lpData = 11001

  If RegCreateKeyEx_(#HKEY_CURRENT_USER, "SOFTWARE\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", 0, #Null, #REG_OPTION_VOLATILE, #KEY_ALL_ACCESS, #Null, @phkResult, @lpdwDisposition) = #ERROR_SUCCESS
    RegSetValueEx_(phkResult, lpValueName, 0, #REG_DWORD, @lpData, SizeOf(LONG))
    RegCloseKey_(phkResult)

    If OpenWindow(0, 0, 0, nWidth * 2 + 16, nHeight + 58, "HTML5 AS3: Webcam", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
      WebGadget(0, 0, 50, nWidth * 2 + 16, nHeight, #Null$)
      FrameGadget(1, 65, 17, 199, 24, #Null$, #PB_Frame_Flat)
      CheckBoxGadget(2, 75, 19, 180, 20, "Save Base64 Encoded Snapshot", #PB_CheckBox_Right)
      ButtonGadget(3, 385, 9, 200, 40, "Convert Snapshot to PB Image")
      SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
      SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
      WebBrowser2.IWebBrowser2 = GetWindowLongPtr_(GadgetID(0), #GWL_USERDATA)
      WebBrowser2\put_Silent(#True)
      ScriptJS = #TAB$ + #TAB$ + "<script type='text/javascript'>" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + "function saveBase64(blob){/*JHPJHP*/}" + #LF$ +
                 #TAB$ + #TAB$ + "</script>" + #LF$
      ScriptDIV.s = #TAB$ + #TAB$ + #TAB$ + "data-preview-width='" + Str(nWidth) + "' data-preview-height='" + Str(nHeight) + "'" + #LF$ +
                    #TAB$ + #TAB$ + #TAB$ + "data-resolution-width='" + Str(nWidth) + "' data-resolution-height='" + Str(nHeight) + "'" + #LF$
      IncludeFile "Includes\as3_webcam.pbi"
      CheckBoxHandler() : BindGadgetEvent(2, @CheckBoxHandler()) : BindGadgetEvent(3, @ButtonHandler())
      HideWindow(0, 0)
      Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
    EndIf

    If RegOpenKeyEx_(#HKEY_CURRENT_USER, "SOFTWARE\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", 0, #KEY_SET_VALUE, @phkResult) = #ERROR_SUCCESS
      RegDeleteValue_(phkResult, lpValueName)
      RegCloseKey_(phkResult)
    EndIf
  Else
    MessageRequester("HTML5 AS3: Webcam", "Registry update failed." + #LF$ + #LF$ + "Operation cancelled.", #MB_ICONERROR)
  EndIf
EndProcedure

UseJPEGImageDecoder() : UseJPEGImageEncoder()
WebcamFolder.s = ReplaceString(GetCurrentDirectory(), "\", "/")
BuildCam(WebcamFolder, 320, 240)
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableXP
; UseIcon = Binaries\webcam.ico
; DisableDebugger
; EnableUnicode