$(function() {
    $('#webcam').webcam({
        noCameraFound: function () {
            this.debug('error', 'Web camera is not available');
        },

        error: function(e) {
            this.debug('error', 'Internal camera plugin error');
        },

        cameraDisabled: function () {
            this.debug('error', 'Please allow access to your camera');
        },

        debug: function(type, string) {
            if (type == 'error') {
                $(".webcam-error").html(string);
            } else {
                $(".webcam-error").html('');
            }
        },

        cameraEnabled:  function () {
            this.debug('notice', 'Camera enabled');
            if (this.isCameraEnabled) return;

            this.isCameraEnabled = true;
            $('#popup-webcam-cams')
                .append($.map(this.getCameraList(), function(cam, i) {
                    return '<option value="' + i + '">' + cam + '</option>';
                }).join(''));

            setTimeout($.proxy(function() {
                this.setCamera('0');
                $('#popup-webcam-cams').show();
                $('#popup-webcam-take-photo')
                    .prop('disabled', false)
                    .show();
            }, this), 750);
        }
    });

    $('#popup-webcam-cams').change(function() {
        var $cam = $('#webcam');
        var success = $cam.webcam('setCamera', $(this).val());
        if (!success) {
            $cam.webcam('debug', 'error', 'Unable to select camera');
        } else {
            $cam.webcam('debug', 'notice', 'Camera changed');
        }
    });

    $('#popup-webcam-take-photo').click(function(e) {
        e.preventDefault();

        var api = $('#webcam').data('webcam');
        var result = api.save();
        if (result && result.length) {
            var shotResolution = api.getResolution();

            var img = new Image();
            img.src = 'data:image/jpeg;base64,' + result;
            $('#result').replaceWith("<div id='result'></div>");
            $('#result').append(img);
            document.title = result;
						saveBase64(img.src);

      //      alert('base64encoded jpeg (' + shotResolution[0] + 'x' + shotResolution[1] + '): ' + result.length + 'chars');

            /* resume camera capture */
            api.setCamera($('#popup-webcam-cams').val());
        } else {
            api.debug('error', 'Broken camera');
        }
    });
});