﻿Global VideoHolder.s = #Null$, VideoPlayer1.s = #Null$, VideoPlayer2.s = #Null$

Procedure SetVideoSize(PageTitle.s)
  nPosition = FindString(PageTitle, "x")

  If nPosition
    ExamineDesktops()
    DesktopWidth = DesktopWidth(0)
    DesktopHeight = DesktopHeight(0)
    VideoWidth = Val(Left(PageTitle, nPosition)) + 16
    VideoHeight = Val(Mid(PageTitle, nPosition + 1)) + 16 + 92
    ResizeWindow(0, DesktopWidth / 2 - VideoWidth / 2 - 4, DesktopHeight / 2 - VideoHeight / 2 - 16, VideoWidth, VideoHeight)
    ResizeGadget(0, 0, 0, VideoWidth, VideoHeight)

    If WindowWidth(0) < GadgetX(5) + GadgetWidth(5) + 10
      HideGadget(3, 1) : HideGadget(4, 1) : HideGadget(5, 1)
    Else
      HideGadget(3, 0) : HideGadget(4, 0) : HideGadget(5, 0)
    EndIf

    If WindowWidth(0) < GadgetX(3) : HideGadget(1, 1) : HideGadget(2, 1) : Else : HideGadget(1, 0) : HideGadget(2, 0) : EndIf

  EndIf
EndProcedure

Procedure ButtonSubmitHandler()
  VideoFile.s = Trim(GetGadgetText(4))

  If VideoFile = ""
    VideoFile = "http://vjs.zencdn.net/v/oceans.mp4"
    SetGadgetText(4, VideoFile)
  EndIf
  HTMLCode.s = GetGadgetItemText(0, #PB_Web_HtmlCode)

  If FindString(LCase(HTMLCode), LCase(VideoFile)) = 0
    HTMLCode = ReplaceString(HTMLCode, VideoHolder, VideoFile)
    VideoHolder = VideoFile : HideWindow(0, 1)
    SetGadgetItemText(0, #PB_Web_HtmlCode, HTMLCode)

    Repeat
      PageTitle.s = GetGadgetItemText(0, #PB_Web_PageTitle)

      If FindString(GetGadgetItemText(0, #PB_Web_HtmlCode), VideoFile) And PageTitle <> "" : Break : EndIf : WindowEvent() : Delay(1)

    ForEver

    If PageTitle = "error"
      DisableGadget(2, 1)
      HideWindow(0, 0)
      MessageRequester("HTML5 Video Player with jQuery", "It seems that this video file cannot be found or is not supported." + #LF$ + #LF$ + VideoFile, #MB_ICONSTOP)
    Else
      DisableGadget(2, 0)
      SetVideoSize(PageTitle)
      HideWindow(0, 0)
    EndIf
  EndIf
EndProcedure

Procedure ButtonBrowseHandler()
  Pattern.s = "MP4 Videos (*.mp4)|*.mp4"
  VideoFile.s = OpenFileRequester("Choose a video file", GetCurrentDirectory() + "TestFiles\", Pattern, 0)

  If FileSize(VideoFile) > 0
    SetGadgetText(4, VideoFile)
    ButtonSubmitHandler()
  EndIf
EndProcedure

Procedure CheckBoxHandler()
  VideoFile.s = "http://vjs.zencdn.net/v/oceans.mp4"

  If GetGadgetState(2)
    SetWindowTitle(0, "HTML5 Video Player with jQuery")
    HTMLCode.s = VideoPlayer1
    HTMLCode = ReplaceString(HTMLCode, VideoFile, VideoHolder)
  Else
    SetWindowTitle(0, "HTML5 Video Player")
    HTMLCode.s = VideoPlayer2
    HTMLCode = ReplaceString(HTMLCode, VideoFile, VideoHolder)
  EndIf
  SetGadgetItemText(0, #PB_Web_HtmlCode, HTMLCode)
EndProcedure

Procedure BuildPlayer(VideoFile.s, VideoFolder.s, VideoZoom.d = 1)
  lpValueName.s = GetFilePart(ProgramFilename()) : lpData = 11001

  If RegCreateKeyEx_(#HKEY_CURRENT_USER, "SOFTWARE\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", 0, #Null, #REG_OPTION_VOLATILE, #KEY_ALL_ACCESS, #Null, @phkResult, @lpdwDisposition) = #ERROR_SUCCESS
    RegSetValueEx_(phkResult, lpValueName, 0, #REG_DWORD, @lpData, SizeOf(LONG))
    RegCloseKey_(phkResult)

    If OpenWindow(0, 0, 0, 500, 500, "HTML5: Video Player - Custom", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
      WebGadget(0, 0, 0, 500, 500, #Null$)
      FrameGadget(1, 385, 10, 94, 24, #Null$, #PB_Frame_Flat)
      CheckBoxGadget(2, 395, 12, 75, 20, "Add jQuery", #PB_CheckBox_Right) : SetGadgetState(2, 1)
      GadgetToolTip(2, "Applies to the Seek Bar")
      UsePNGImageDecoder()

      If LoadImage(0, "Binaries\video.png")
        ButtonImageGadget(3, 490, 7, 40, 30, ImageID(0))
        GadgetToolTip(3, "Browse for Video")
      EndIf
      StringGadget(4, 540, 12, 230, 20, VideoFile)
      GadgetToolTip(4, "Clear and Submit for Default Video")

      If LoadImage(0, "Binaries\submit.png")
        ButtonImageGadget(5, 780, 7, 40, 30, ImageID(0))
        GadgetToolTip(5, "Submit Video")
      EndIf
      SetWindowLongPtr_(GadgetID(0), #GWL_STYLE, GetWindowLongPtr_(GadgetID(0), #GWL_STYLE) | #WS_CLIPSIBLINGS)
      SetWindowPos_(GadgetID(0), #HWND_BOTTOM, #Null, #Null, #Null, #Null, #SWP_NOSIZE | #SWP_NOMOVE)
      SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
      SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
      WebBrowser2.IWebBrowser2 = GetWindowLongPtr_(GadgetID(0), #GWL_USERDATA)
      WebBrowser2\put_Silent(#True)
      IncludeFile "Includes\videoplayer_custom1.pbi"
      IncludeFile "Includes\videoplayer_custom2.pbi"
      SetGadgetItemText(0, #PB_Web_HtmlCode, VideoPlayer1)

      Repeat
        PageTitle.s = GetGadgetItemText(0, #PB_Web_PageTitle)

        If FindString(GetGadgetItemText(0, #PB_Web_HtmlCode), VideoFile) And PageTitle <> "" : Break : EndIf : WindowEvent() : Delay(1)

      ForEver

      If PageTitle = "error" : DisableGadget(2, 1) : SetVideoSize("530x510") : Else : SetVideoSize(PageTitle) : EndIf

      BindGadgetEvent(2, @CheckBoxHandler())

      If IsGadget(3) : BindGadgetEvent(3, @ButtonBrowseHandler()) : EndIf
      If IsGadget(5) : BindGadgetEvent(5, @ButtonSubmitHandler()) : EndIf

      VideoHolder = VideoFile

      If PageTitle = "error"
        If FileSize(VideoFolder + "TestFiles/moon.mp4") > 0
          BuildPlayer(VideoFolder + "TestFiles/moon.mp4", VideoFolder, 0.7)
        Else
          MessageRequester("HTML5 Video Player with jQuery", "It seems that this video file cannot be found or is not supported." + #LF$ + #LF$ + VideoFile, #MB_ICONSTOP)
        EndIf
      EndIf
      StickyWindow(0, 1) :  : HideWindow(0, 0)
      Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
    EndIf

    If RegOpenKeyEx_(#HKEY_CURRENT_USER, "SOFTWARE\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", 0, #KEY_SET_VALUE, @phkResult) = #ERROR_SUCCESS
      RegDeleteValue_(phkResult, lpValueName)
      RegCloseKey_(phkResult)
    EndIf : End
  Else
    MessageRequester("HTML5: Video Player - Custom", "Registry update failed." + #LF$ + #LF$ + "Operation cancelled.", #MB_ICONERROR)
  EndIf
EndProcedure

VideoFile.s = "http://vjs.zencdn.net/v/oceans.mp4"
VideoFolder.s = ReplaceString(GetCurrentDirectory(), "\", "/")
BuildPlayer(VideoFile, VideoFolder, 1.5)
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 1
; Folding = -
; EnableXP
; UseIcon = Binaries\video.ico
; DisableDebugger
; EnableUnicode